// Code generated by "requestgen -method GET -type DerivativesRequest -url /v1/metrics/derivatives/:metric -responseType Response"; DO NOT EDIT.

package glassnode

import (
	"context"
	"encoding/json"
	"fmt"
	"net/url"
	"regexp"
)

func (d *DerivativesRequest) SetAsset(Asset string) *DerivativesRequest {
	d.Asset = Asset
	return d
}

func (d *DerivativesRequest) SetSince(Since int64) *DerivativesRequest {
	d.Since = Since
	return d
}

func (d *DerivativesRequest) SetUntil(Until int64) *DerivativesRequest {
	d.Until = Until
	return d
}

func (d *DerivativesRequest) SetInterval(Interval Interval) *DerivativesRequest {
	d.Interval = Interval
	return d
}

func (d *DerivativesRequest) SetFormat(Format Format) *DerivativesRequest {
	d.Format = Format
	return d
}

func (d *DerivativesRequest) SetTimestampFormat(TimestampFormat string) *DerivativesRequest {
	d.TimestampFormat = TimestampFormat
	return d
}

func (d *DerivativesRequest) SetMetric(Metric string) *DerivativesRequest {
	d.Metric = Metric
	return d
}

// GetQueryParameters builds and checks the query parameters and returns url.Values
func (d *DerivativesRequest) GetQueryParameters() (url.Values, error) {
	var params = map[string]interface{}{}
	// check Asset field -> json key a
	Asset := d.Asset

	// TEMPLATE check-required
	if len(Asset) == 0 {
		return nil, fmt.Errorf("a is required, empty string given")
	}
	// END TEMPLATE check-required

	// assign parameter of Asset
	params["a"] = Asset
	// check Since field -> json key s
	Since := d.Since

	// assign parameter of Since
	params["s"] = Since
	// check Until field -> json key u
	Until := d.Until

	// assign parameter of Until
	params["u"] = Until
	// check Interval field -> json key i
	Interval := d.Interval

	// assign parameter of Interval
	params["i"] = Interval
	// check Format field -> json key f
	Format := d.Format

	// assign parameter of Format
	params["f"] = Format
	// check TimestampFormat field -> json key timestamp_format
	TimestampFormat := d.TimestampFormat

	// assign parameter of TimestampFormat
	params["timestamp_format"] = TimestampFormat

	query := url.Values{}
	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParameters builds and checks the parameters and return the result in a map object
func (d *DerivativesRequest) GetParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}

	return params, nil
}

// GetParametersQuery converts the parameters from GetParameters into the url.Values format
func (d *DerivativesRequest) GetParametersQuery() (url.Values, error) {
	query := url.Values{}

	params, err := d.GetParameters()
	if err != nil {
		return query, err
	}

	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParametersJSON converts the parameters from GetParameters into the JSON format
func (d *DerivativesRequest) GetParametersJSON() ([]byte, error) {
	params, err := d.GetParameters()
	if err != nil {
		return nil, err
	}

	return json.Marshal(params)
}

// GetSlugParameters builds and checks the slug parameters and return the result in a map object
func (d *DerivativesRequest) GetSlugParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}
	// check Metric field -> json key metric
	Metric := d.Metric

	// assign parameter of Metric
	params["metric"] = Metric

	return params, nil
}

func (d *DerivativesRequest) applySlugsToUrl(url string, slugs map[string]string) string {
	for k, v := range slugs {
		needleRE := regexp.MustCompile(":" + k + "\\b")
		url = needleRE.ReplaceAllString(url, v)
	}

	return url
}

func (d *DerivativesRequest) GetSlugsMap() (map[string]string, error) {
	slugs := map[string]string{}
	params, err := d.GetSlugParameters()
	if err != nil {
		return slugs, nil
	}

	for k, v := range params {
		slugs[k] = fmt.Sprintf("%v", v)
	}

	return slugs, nil
}

func (d *DerivativesRequest) Do(ctx context.Context) (Response, error) {

	// no body params
	var params interface{}
	query, err := d.GetQueryParameters()
	if err != nil {
		return nil, err
	}

	apiURL := "/v1/metrics/derivatives/:metric"
	slugs, err := d.GetSlugsMap()
	if err != nil {
		return nil, err
	}

	apiURL = d.applySlugsToUrl(apiURL, slugs)

	req, err := d.Client.NewAuthenticatedRequest(ctx, "GET", apiURL, query, params)
	if err != nil {
		return nil, err
	}

	response, err := d.Client.SendRequest(req)
	if err != nil {
		return nil, err
	}

	var apiResponse Response
	if err := response.DecodeJSON(&apiResponse); err != nil {
		return nil, err
	}
	return apiResponse, nil
}
